

function Subform( subformId, basePath, childSide, operation, relationClass, parentNode, select, childLimit, typeName, fieldName, imagePath, hoisting ) {

  var table = $( ("#table" + subformId).replace("-", "_") )[0];
  var children = {}, childCount = 0, newLink, selectLink, selectRow;
  
  var that = this;

  this.addChild = function( relationId ) {
    if( (!children[relationId]) && (childCount < childLimit) )
    {
    
      var nodeLoad = function(html){
        
        if( nodeCell.childNodes.length > 0 )
        {
          nodeCell.removeChild( nodeCell.childNodes[0] );
        }
        
        var nodeDiv = newDiv();
        nodeDiv.className = "subformChildDiv";
        nodeDiv.innerHTML = html;

        children[relationId].forms = { save: newDiv(), remove: newDiv() };
        
        copyForm( children[relationId].forms.save, $("#node-form", nodeDiv)[0] );
        copyForm( children[relationId].forms.remove, $("#subform_delete_relation_instance", nodeDiv)[0] );
      
        nodeCell.appendChild( nodeDiv );
        
        if( typeof autocompleteAutoAttach != 'undefined' ){ autocompleteAutoAttach(); }
        if( typeof collapseAutoAttach != 'undefined' ){ collapseAutoAttach(); }
      }
      
      var newRow = table.insertRow(-1);
      children[relationId] = { row: newRow };
      if( operation == "edit" ) {
      
        children[relationId].removeLink = createSubformButton("Remove", "delete.png", function(){that.removeChild(relationId); return false;});
        children[relationId].saveLink = createSubformButton("Save", "add.png",
          function()
          {
            if( children[relationId].forms.save.valid )
            {
              $(children[relationId].forms.save).ajaxSubmit({
                success: function(html){
                  nodeLoad(html);
                  if( relationId == -1 )
                  {
                    if( $("#edit-relation_instance_id", nodeCell)[0] )
                    {
                      relationId = $("#edit-relation_instance_id", nodeCell)[0].value;
                      that.syncChild( relationId );
                    }
                  }
                }
              });
            }
            return false;
          }
        );
        if (hoisting) {
          children[relationId].hoistLink = createSubformButton("Hoist", "arrow_up.png", function(){window.location = basePath + "subform_related/" + relationId + "/" + childSide + "/hoist";});
        }
        
        var removeCell = newRow.insertCell(newRow.childNodes.length);
        removeCell.id = "subform_remove_cell";
        removeCell.className = "subform_remove_cell";
        removeCell.appendChild( children[relationId].removeLink );
        removeCell.appendChild( children[relationId].saveLink );
        if (hoisting) {
          removeCell.appendChild( children[relationId].hoistLink );
        }
        
      }
      var nodeCell = newRow.insertCell(newRow.childNodes.length);
      nodeCell.colSpan = 3 - newRow.childNodes.length;
      children[relationId].nodeCell = nodeCell;
      if( relationId == -1 )
      {
        $.ajax({
          url: basePath + "subform_related/" + relationClass + "/" + childSide + "/" + parentNode + "/add",
          type: 'GET', dataType: 'html', timeout: 20000,
          error: function(){
            alert('Error loading new child form.');
          },
          success: nodeLoad
        });
      }
      else if( operation != "hide" )
      {
        $.ajax({
          url: basePath + "subform_related/" + relationId + "/" + childSide + "/" + operation,
          type: 'GET', dataType: 'html', timeout: 20000,
          error: function(){
            alert('Error loading child.');
          },
          success: nodeLoad
        });
      }
      
      childCount++;
    }
    this.refresh();
  }
  this.syncChild = function( relationId ) {
    if( !children[relationId] && children[-1] )
    {
      table[relationId] = table[-1];
      children[relationId] = children[-1];

      // children[relationId].removeLink.onclick = function(){that.removeChild(relationId); return false;};
      // children[relationId].saveLink.onclick = function(){that.removeChild(relationId); return false;};

      delete children[-1];
    }
    this.refresh();
  }
  this.removeChild = function( relationId ) {
    if( children[relationId] )
    {
      if( children[relationId].forms.remove && children[relationId].forms.remove.valid )
      {
        $(children[relationId].forms.remove).ajaxSubmit({
          success: function(html){
            table.deleteRow( children[relationId].row.sectionRowIndex );
            delete children[relationId];
            childCount--;
            that.refresh();
          }
        });
      }
      else
      {
        table.deleteRow( children[relationId].row.sectionRowIndex );
        delete children[relationId];
        childCount--;
        that.refresh();
      }
    }
  }
  this.showSelectList = function() {
    if( !selectRow )
    {
    
      var formSelect = document.createElement("div");
    
      var selectLoad = function(html){
          
        selectCell.innerHTML = "";
        
        var selectDiv = newDiv();
        selectDiv.className = "subformChildDiv";
        selectDiv.innerHTML = html;
      
        for(var i=0; i < selectDiv.childNodes.length; i++)
        {
          if( selectDiv.childNodes[i].id == "_subform_select" )
          {
            copyForm( formSelect, selectDiv.childNodes[i] );
          }
        }
        
        selectCell.appendChild( selectDiv );
        // Table.auto();
      }
      
      selectRow = table.insertRow(-1);
      
      var cancelLink = createSubformButton("Cancel", "delete.png", function(){that.hideSelectList(); return false;});
      var submitLink = createSubformButton("Submit", "add.png", 
        function()
        {
          selectCell.style.display = "none";
          if( formSelect && formSelect.valid )
          {
            $(formSelect).ajaxSubmit({
              success: function(html){
                var newRelationInstances = html.split(",");
                if( html.length > 0 )
                {
                  for(var i=0; i < newRelationInstances.length; i++)
                  {
                    if( !isNaN(newRelationInstances[i]) )
                    {
                      that.addChild(newRelationInstances[i]);
                    }
                  }
                }
                else
                {
                  that.hideSelectList();
                }
                that.hideSelectList();
              }
            });
          }
          
          return false;
        }
      );
      
      var operationsCell = selectRow.insertCell(0);
      operationsCell.className = "subform_remove_cell"; // TODO: needs its own css, or better class name
      
      operationsCell.appendChild( cancelLink );
      operationsCell.appendChild( document.createElement("br") );
      operationsCell.appendChild( submitLink );
      
      var selectCell = selectRow.insertCell(1);
      
      $.ajax({
        url: basePath + "subform_select/" + typeName + "/" + fieldName + "/" + parentNode + "/" + childSide,
        type: 'GET', dataType: 'html', timeout: 20000,
        error: function(){
          alert('Error loading child.');
        },
        success: selectLoad
      });
      
      that.refresh();
    }
  }
  this.hideSelectList = function() {
    if( selectRow )
    {
      table.deleteRow( selectRow.sectionRowIndex );
      selectRow = null;
      that.refresh();
    }
  }
  this.renderLinks = function() {
    that.newLink = createSubformButton("New", "add.png", function(){that.addChild(-1);}, "horizontal" );
    that.selectLink = createSubformButton("Select", "database_add.png", function(){that.showSelectList();}, "horizontal" );
    table.parentNode.appendChild( that.newLink );
    table.parentNode.appendChild( that.selectLink );
  }
  this.refresh = function() {
    that.newLink.style.visibility = ((childCount < childLimit) && (operation == "edit") && (!children[-1])) ? "visible" : "hidden";
    that.selectLink.style.visibility = ((childCount < childLimit) && select && (operation == "edit") && !selectRow ) ? "visible" : "hidden";
  }
  
  function createSubformButton( text, image, onclick, horizontal ) {
    var subformButton = document.createElement("A");
    subformButton.innerHTML = "<img src='/" + imagePath + "/" + image + "'>" + ( !horizontal ? "<br>" : "" ) + text;
    subformButton.setAttribute('href', '#');
    subformButton.className = 'subform_button';
    subformButton.onclick = onclick;
    subformButton.style.display = ( !horizontal ? "block" : "inline" );
    return subformButton;
  }
  
  function Child( relationInstanceId, nodeId )
  {
    this.src = "";
    this.innerHTML = "";
    this.relationInstanceId = relationInstanceId;
    this.nodeId = nodeId;
    
    this.row = {};
    this.removeForm = {};
    
    if( relationId == -1 )
      this.src = basePath + "subform_related/" + relationClass + "/" + childSide + "/" + parentNode + "/add";
    else if( operation != "hide" )
      this.src = basePath + "subform_related/" + relationId + "/" + childSide + "/" + operation;
    
    $.ajax({
      url: this.src,
      type: 'GET',
      dataType: 'html',
      timeout: 20000,
      error: function(){
        alert('Error loading child.');
      },
      success: function(html){
        this.innerHTML = "<div class='" + divClass + "'>" + html + "</div>";
      }
    });
  }

}

function copyArray(sourceArray)
{
  returnArray = [];
  for(i=0;i<sourceArray.length;i++)
  {
    returnArray[i] = sourceArray[i];
  }
  return returnArray;
}

function copyForm(destinationForm, sourceForm)
{
  if( sourceForm )
  {
    destinationForm.setAttribute( 'target', sourceForm.getAttribute('target') );
    destinationForm.setAttribute( 'action', sourceForm.getAttribute('action') );
    destinationForm.setAttribute( 'method', sourceForm.getAttribute('method') );
    destinationForm.elements = copyArray( sourceForm.elements );
    destinationForm.valid = true;
  }
}

function newDiv()
{
  return document.createElement('div');
}




